routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'Frontend\PageController@landing')->name('landing');
Route::get('/about', 'Frontend\PageController@pageAbout')->name('page.about');
Route::post('/vehicle/detail', 'Frontend\PageController@showVehicle')->name('vehicle.detail');

Route::group(['middleware' => ['auth', 'role:member']], function () {
    Route::get('/booking/cart', 'Frontend\PageController@cart')->name('cart.index');
    Route::get('/booking/{company_id}/checkout', 'Frontend\PageController@checkout')->name('checkout');
    Route::get('/booking/{invoice}/confirm', 'Frontend\PageController@confirm')->name('confirm');
    Route::post('/booking/{invoice}/confirm', 'Frontend\PageController@confirmStore')->name('confirm.store');
    Route::post('/booking/{company_id}/checkout', 'Frontend\PageController@checkoutStore')->name('checkout.store');
    Route::post('/booking/cart', 'Frontend\PageController@addToCart')->name('cart.add');
    Route::post('/booking/cart/remove', 'Frontend\PageController@removeItemCart')->name('cart.remove');
    Route::post('/booking/cart/update', 'Frontend\PageController@updateCart')->name('cart.update');
    Route::post('/booking/cart/dateadd', 'Frontend\PageController@addDateCart')->name('cart.dateadd');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::get('/account/profile', 'ProfileController@show')->name('profile.show');
Route::put('/account/profile', 'ProfileController@update')->name('profile.update');
Route::put('/account/profile/member', 'ProfileController@updateMember')->name('profile.update.member');

Route::group(['prefix' => 'main', 'middleware' => ['auth', 'role:admin']], function () {
    Route::get('user', 'Backend\UserController@index' )->name('user.index');
    Route::post('user', 'Backend\UserController@store' )->name('user.store');
    Route::get('user/create', 'Backend\UserController@create' )->name('user.create');
    Route::get('user/{id}/edit', 'Backend\UserController@edit' )->name('user.edit');
    Route::put('user/{id}/update', 'Backend\UserController@update' )->name('user.update');
    Route::delete('user/{id}', 'Backend\UserController@destroy' )->name('user.destroy');

    Route::resource('booking','Backend\BookingController', ['only' => ['index', 'show', 'update']]);
    Route::resource('payment','Backend\PaymentController', ['only' => ['index', 'show', 'update']]);
    Route::resource('company','Backend\CompanyController', ['only' => ['index', 'show']]);
    Route::post('company.verification', 'Backend\CompanyController@verification')->name('company.verification');
    Route::resource('payouts', 'Backend\PayoutController', ['only' => ['index', 'show', 'update']]);
});

Route::group(['prefix' => 'intern', 'middleware' => ['auth', 'role:member']], function () {
    Route::resource('vehicle', 'Frontend\VehicleController');
    Route::resource('payout','Frontend\PayoutController', ['only' => ['index', 'show', 'create', 'store']]);
    Route::resource('transaction_in', 'Frontend\TransInController', ['only' => ['index', 'show', 'edit', 'update']]);
    Route::resource('transaction_out', 'Frontend\TransOutController', ['only' => ['index', 'show']]);
});

app/Http/Controllers/Backend/PayoutController.php
<?php

namespace App\Http\Controllers\Backend;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Support\Facades\File;
use Yajra\Datatables\Datatables;
use App\User;
use App\Company;
use App\Booking;
use App\Payout;
use Auth;
use Session;
use Carbon\Carbon;

class PayoutController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        if ($request->ajax()) {

            $payouts = Payout::with('company', 'admin');

            if ($request->get('status') != null) {
                if ($request->status != 'all') {
                    $payouts->whereStatus($request->status);
                }
            }

            $payouts = $payouts->select('payouts.*');

            return Datatables::of($payouts)
                ->addIndexColumn()
                ->addColumn('action', function ($payout) {
                    return view('partials._action', [
                        'model'           => $payout,
                        'show_url'        => route('payouts.show', $payout->id)
                    ]);
                })
                ->escapeColumns([])
                ->make(true);
        }

        return view('backend.payouts.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $payout = Payout::find($id);

        return view('backend.payouts.show')->with(compact('payout'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        if ($request->status == 10) {
            $this->validate($request, [
                'reject_reason' => 'required|string'
            ]);
            $is_payout = 0;
        } else {
            $this->validate($request, [
                'image' => 'required|image'
            ]);
            $is_payout = 1;
        }

        $payout = Payout::find($id);
        $payout->admin_id = Auth::user()->id;
        $payout->status = $request->status;
        $payout->is_payout = $is_payout;

        if ($request->hasFile('image')) {
            // megnambil image yang diupload berikut ekstensinya
            $filename = null;
            $uploaded_image = $request->file('image');
            $extension = $uploaded_image->getClientOriginalExtension();
            // membuat nama file random dengan extension
            $filename = uniqid() . '.' . $extension;
            $destinationPath = public_path() . DIRECTORY_SEPARATOR . 'uploads' . DIRECTORY_SEPARATOR . 'images' . DIRECTORY_SEPARATOR . 'payouts';
            // memindahkan file ke folder public/images
            $uploaded_image->move($destinationPath, $filename);

            $payout->image = $filename;
        }

        if ($request->status == 10) {
            $payout->reject_reason = $request->reject_reason;
        }

        $payout->save();

        Session::flash("flash_notification", [
            "level" => "success",
            "message" => "Pencairan ini berhasil diproses"
        ]);

        return redirect()->route('payouts.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/Frontend/PageController.php
<?php

namespace App\Http\Controllers\Frontend;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Vehicle;
use App\Booking;
use App\BookingDetail;
use App\Payment;
use Session;

class PageController extends Controller
{
    public function landing(Request $request)
    {
        $vehicles = Vehicle::where('status', 100);

        $condition = (env('DB_CONNECTION', 'mysql') == 'pgsql') ? 'ilike' : 'like';

        if ($request->get('q') != null) {
            if ($request->q != 'all') {
                $vehicles->where('name', $condition, '%' . $request->q . '%');
            }
        }

        $vehicles = $vehicles->paginate(8);

        $q = $request->q;
        $company_id = null;
        if (\Auth::check()) {
            if (\Auth::user()->role == 'member') {
                $company_id = \Auth::user()->company->id;
            }
        }

        return view('frontend.pages.landing')->with(compact('vehicles', 'q', 'company_id'));
    }

    public function pageAbout()
    {
        return view('frontend.pages.about');
    }

    public function showVehicle(Request $request)
    {
        $vehicle = Vehicle::with('company')->find($request->id);

        return response()->json($vehicle);
    }

    public function Cart(Request $request)
    {
        $carts = session('cart') ?? [];
        //dd($carts);
        return view('frontend.pages.cart')->with(compact('carts'));
    }

    public function addToCart(Request $request)
    {
        $id = $request->bus_id;
        $vehicle = Vehicle::find($id);

        $cart = session()->get('cart');
        
        $company_id = $vehicle->company_id;
        $company_name = $vehicle->company->name;
        // if cart is empty then this the first product
        if (!$cart) {
            $cart = [
                $company_id => [
                    'company_name' => $company_name,
                    'data' => [
                        $id => [
                            "id" => $vehicle->id,
                            "name" => $vehicle->name,
                            "quantity" => 1,
                            "available" => $vehicle->available,
                            "image_url" => asset('uploads/images/vehicles/' . $vehicle->image),
                            "seat" => $vehicle->seat,
                            "price" => $vehicle->price
                        ]
                    ]
                ]
            ];

            session()->put('cart', $cart);

            Session::flash("swal_notification", [
                "level" => "success",
                "message" => "Bus berhasil ditambahkan ke list booking"
            ]);

            return redirect()->back();
        }

        // if cart not empty then check if this product exist then increment quantity
        if (isset($cart[$company_id]['data'][$id])) {

            if($cart[$company_id]['data'][$id]['quantity'] < $cart[$company_id]['data'][$id]['available']){
                $cart[$company_id]['data'][$id]['quantity']++;
            }

            session()->put('cart', $cart);

            Session::flash("swal_notification", [
                "level" => "success",
                "message" => "Bus berhasil ditambahkan ke list booking"
            ]);
            return redirect()->back();
        }

        // if item not exist in cart then add to cart with quantity = 1
        $cart[$company_id]['company_name'] = $company_name;
        $cart[$company_id]['data'][$id] = [
            "id" => $vehicle->id,
            "name" => $vehicle->name,
            "quantity" => 1,
            "available" => $vehicle->available,
            "image_url" => asset('uploads/images/vehicles/' . $vehicle->image),
            "seat" => $vehicle->seat,
            "price" => $vehicle->price
        ];

        session()->put('cart', $cart);

        Session::flash("swal_notification", [
            "level" => "success",
            "message" => "Bus berhasil ditambahkan ke list booking"
        ]);
        return redirect()->back();
    }

    public function updateCart(Request $request)
    {
        $status = 0;
        if ($request->company_id and $request->vehicle_id and $request->quantity) {
            $cart = session()->get('cart');

            $cart[$request->company_id]['data'][$request->vehicle_id]['quantity'] = $request->quantity;

            session()->put('cart', $cart);

            $status = 1;
        }
        if ($status == 1) {
            Session::flash("swal_notification", [
                "level" => "success",
                "message" => "Tanggal sewa berhasil ditambahkan"
            ]);
        } else {
            Session::flash("swal_notification", [
                "level" => "error",
                "message" => "Gagal terjadi kesalahan!"
            ]);
        }

        return redirect()->back();
    }

    public function addDateCart(Request $request)
    {
        $status = 0;
        if ($request->company_id and $request->start_date and $request->end_date) {
            $cart = session()->get('cart');

            $cart[$request->company_id]['date_range'] = $request->date_range;
            $cart[$request->company_id]['start_date'] = $request->start_date;
            $cart[$request->company_id]['end_date'] = $request->end_date;
            $cart[$request->company_id]['diff_days'] = $request->diff_days;

            session()->put('cart', $cart);

            $status = 1;
        }
        
        if ($status == 1) {
            Session::flash("swal_notification", [
                "level" => "success",
                "message" => "Tanggal sewa berhasil ditambahkan"
            ]);
        } else {
            Session::flash("swal_notification", [
                "level" => "error",
                "message" => "Gagal terjadi kesalahan!"
            ]);
        }
        return redirect()->back();
    }

    public function removeItemCart(Request $request)
    {
        $status = 0;
        if ($request->company_id and $request->vehicle_id) {

            $cart = session()->get('cart');
            if (isset($cart[$request->company_id]['data'][$request->vehicle_id])) {

                unset($cart[$request->company_id]['data'][$request->vehicle_id]);

                if (empty($cart[$request->company_id]['data'])) {
                    unset($cart[$request->company_id]);
                }

                session()->put('cart', $cart);

                $status = 1;
            }
        }
        if ($status == 1) {
            Session::flash("swal_notification", [
                "level" => "success",
                "message" => "Bus berhasil dihapus"
            ]);
        } else {
            Session::flash("swal_notification", [
                "level" => "error",
                "message" => "Gagal terjadi kesalahan!"
            ]);
        }
        return redirect()->back();
    }

    public function checkout($company_id)
    {
        $cart = session('cart')[$company_id] ?? [];

        if (empty($cart)) {
            abort(404);
        }

        return view('frontend.pages.checkout')->with(compact('cart', 'company_id'));
    }

    public function checkoutStore(Request $request, $company_id)
    {
        $cart = session('cart')[$company_id] ?? [];
        if (empty($cart)) {
            abort(404);
        }

        $booking = new Booking();
        $booking->invoice = strtoupper(uniqid());
        $booking->customer_id = \Auth::user()->id;
        $booking->company_id = $company_id;
        $booking->start_date = $cart['start_date'] ?? date('Y-m-d');
        $booking->end_date = $cart['end_date'] ?? date('Y-m-d');
        $booking->notes = $request->notes;
        $booking->vehicle_total = 0;
        $booking->price_total = 0;
        $booking->payment_method = $request->method;
        $booking->save();

        $price_total = 0;
        $vehicle_total = 0;
        $subtotal = 0;
        foreach ($cart['data'] as $key => $item) {
            $detail = new BookingDetail();
            $detail->booking_id = $booking->id;
            $detail->vehicle_id = $item['id'];
            $detail->quantity = $item['quantity'];
            $detail->price = $item['price'];
            $detail->save();

            $price_total = $item['quantity'] * $item['price'];
            $subtotal += $price_total;
            $vehicle_total += $item['quantity'];
        }

        $booking->vehicle_total = $vehicle_total;
        $booking->price_total = $subtotal * ($cart['diff_days'] ?? 1);
        $booking->save();

        // remove cart
        $carts = session('cart');
        unset($carts[$request->company_id]);
        session()->put('cart', $carts);

        Session::flash("swal_notification", [
            "level" => "success",
            "message" => "Checkout berhasil, silahkan lakukan pembayaran"
        ]);
        return redirect()->route('confirm', $booking->invoice);
    }

    public function confirm($invoice)
    {
        $booking = Booking::whereInvoice($invoice)->where('customer_id', \Auth::user()->id)->first();

        if (!$booking) {
            abort(404);
        }

        $bank = config('app-data.bank')[$booking->payment_method];  
        $banks = json_decode(config('app-data.banks'), true);

        return view('frontend.pages.confirm')->with(compact('booking', 'bank', 'banks'));
    }

    public function confirmStore(Request $request, $invoice)
    {
        $this->validate($request, [
            'confirm_bank' => 'required|string',
            'confirm_account_holder' => 'required|string',
            'payment_image' => 'required|image',
        ]);

        $booking = Booking::whereInvoice($invoice)->first();

        $payment = new Payment();
        $payment->booking_id = $booking->id;
        $payment->method = $request->confirm_bank;
        $payment->account_holder = $request->confirm_account_holder;
        $payment->paid = $booking->price_total;

resources/views/frontend/payouts/create.blade.php
@extends('layouts.front')

@section('css')
  <link rel="stylesheet" href="{{ asset('assets/stisla/modules/summernote/summernote-bs4.css') }}">
@endsection

@section('content')
  <section class="section">
    <div class="section-header">
      <h1>Request Pencairan Saldo</h1>
    </div>

    <form id="frm-payout" method="POST" action="{{ route('payout.store') }}" enctype="multipart/form-data">
      <div class="row">
        <div class="col-lg-8">
          <div class="card card-danger">
            <div class="card-header py-3">
              <h6 class="m-0 font-weight-bold">Form Pecairan Saldo</h6>
            </div>
            <div class="card-body">
              {{ csrf_field() }}

              <div class="row">
                <div class="form-group col-12 {{ $errors->has('nominal') ? ' has-error' : '' }}">
                  <label for="nominal">Nominal Pencairan</label>
                  <input id="nominal" type="number" class="form-control @if ($errors->has('nominal')) is-invalid @endif" name="nominal" value="{{ old('nominal') }}" onkeyup="calculate()">
                  @if ($errors->has('nominal'))
                    <div class="invalid-feedback">
                      {{ $errors->first('nominal') }}
                    </div>
                  @endif
                </div>
              </div>

              <div class="row">
                <div class="form-group col-12 {{ $errors->has('admin_fee') ? ' has-error' : '' }}">
                  <label for="admin_fee">Biaya Admin</label>
                  <input id="admin_fee" type="text" class="form-control @if ($errors->has('admin_fee')) is-invalid @endif" name="admin_fee" value="{{ old('admin_fee') ?? 0 }}" readonly>
                  @if ($errors->has('admin_fee'))
                    <div class="invalid-feedback">
                      {{ $errors->first('admin_fee') }}
                    </div>
                  @endif
                </div>
              </div>

              <div class="row">
                <div class="form-group col-12 {{ $errors->has('payout_total') ? ' has-error' : '' }}">
                  <label for="payout_total">Uang Akan Dicairkan</label>
                  <input id="payout_total" type="text" class="form-control @if ($errors->has('payout_total')) is-invalid @endif" name="payout_total" value="{{ old('payout_total') ?? 0 }}" readonly>
                  @if ($errors->has('payout_total'))
                    <div class="invalid-feedback">
                      {{ $errors->first('payout_total') }}
                    </div>
                  @endif
                </div>
              </div>

              <div class="row">
                <div class="form-group col-12">
                  <label for="payout_total">Nominal Terbilang</label>
                  <h3 class="terbilang">-</h3>
                </div>
              </div>

              <div class="form-group">
                <button type="button" onclick="validate()" class="btn btn-danger btn-block" tabindex="4">
                  Proses Request
                </button>
              </div>
              
            </div>
          </div>
        </div>

        <div class="col-lg-4">
          <div class="row">
             <div class="col-lg-12 col-md-6 col-sm-6 col-12">
              <div class="card card-statistic-1">
                <div class="card-icon bg-info">
                  <i class="fas fa-dollar-sign"></i>
                </div>
                <div class="card-wrap">
                  <div class="card-header">
                    <h4>Saldo Tersimpan</h4>
                  </div>
                  <div class="card-body">
                    Rp {{ rupiah($data['balances']) }}
                  </div>
                </div>
              </div>
            </div>

            <div class="col-lg-12 col-md-6 col-sm-6 col-12">
              <div class="card card-statistic-1">
                <div class="card-icon bg-danger">
                  <i class="fas fa-dollar-sign"></i>
                </div>
                <div class="card-wrap">
                  <div class="card-header">
                    <h4>Saldo Dicairkan</h4>
                  </div>
                  <div class="card-body">
                    Rp {{ rupiah($data['payouts']) }}
                  </div>
                </div>
              </div>
            </div>

            <div class="col-lg-12 col-md-6 col-sm-6 col-12">
              <div class="alert alert-warning">
                <strong><i class="fa fa-info"></i> Info</strong> <br>
                Pencairan saldo akan dikenakan biaya administrasi sebesar 5% dari total pencairan.
              </div>
            </div>
          </div>
        </div>
      </div>
      <input type="hidden" id="limit" value="{{ $data['balances'] }}">
    </form>
  </section>
@endsection

@section('script')
  <script src="{{ asset('js/terbilang.js') }}"></script>
  <script>
    $(document).ready(function () {
      bsCustomFileInput.init()
      $('.select2').select2();
    });

    function numberFormat(x) {
      return x.toString().replace(/\B(?<!\.\d*)(?=(\d{3})+(?!\d))/g, ".");
    }

    function calculate() {
      let val = $('#nominal').val();
      let result = terbilang(val);
      $('.terbilang').html(result);
      var admin_fee = 0.05 * val;
      $('#admin_fee').val(numberFormat(admin_fee));
      $('#payout_total').val(numberFormat(val - admin_fee));
    }

    function validate() {
      var limit = $('#limit').val();
      let val = $('#nominal').val();
      
      if (val > limit) {
        swal(
          'Perhatian!',
          'Nominal pencairan melebihi saldo yang tersimpan, silahkan cek kembali!',
          'error'
        );
        return;
      }
      
      $('#frm-payout').submit();
    }
  </script>
@endsection

resources/views/frontend/payouts/index.blade.php
@extends('layouts.front')

@section('content')
  <section class="section">
    <div class="section-header">
      <h1>Pencairan Saldo</h1>
    </div>

    <div class="d-sm-flex align-items-center justify-content-start mb-4">
      <a class="btn btn-sm btn-danger mr-auto" href="{{ route('payout.create') }}"><i class="fa fa-plus"></i> Request Pencairan Saldo</a> 
      <div class="form-inline">
        <label>Filter Status</label>
        <select name="status" class="form-control-sm ml-2">
          <option value="all">Semua</option>
          <option value="100">Menunggu Pencairan</option>
          <option value="200">Telah Dicairkan</option>
          <option value="300">Selesai</option>
          <option value="10">Dibatalkan</option>
        </select>
        <button class="btn btn-sm btn-danger ml-2" id="btn-filter"><i class="fas fa-filter"></i></button>
      </div>
    </div>

    <div class="row">
      <div class="col-lg-12">

        <!-- Basic Card Example -->
        <div class="card card-danger">
          <div class="card-header py-3">
            <h6 class="m-0 font-weight-bold">List Pencairan Saldo</h6>
          </div>
          <div class="card-body">

          <div class="table-responsive">
            <table class="table table-striped datatable">
              <thead>                                 
                <tr>
                  <th>#</th>
                  <th>Nominal Pencairan</th>
                  <th>Biaya Administrasi</th>
                  <th>Uang Dicairkan</th>
                  <th>Tgl. Pencairan</th>
                  <th>Status</th>
                  <th>Aksi</th>
                </tr>
              </thead>
              <tbody></tbody>
            </table>
          </div>

          </div>
        </div>
      </div>
    </div>
  </section>
@endsection
@section('script')
<script>
  $(document).ready(function() {
      $('.datatable').DataTable({
          processing: true,
          serverSide: true,
          autoWidth: false,
          language: {
              url: '{{ asset('assets/stisla/modules/datatables/lang/Indonesian.json') }}'
          },
          ajax: {
            url: '{{ route('payout.index') }}',
            data: function (d) {
              d.status = $('select[name=status]').val()
            }
          },
          columns: [
            {data: 'DT_RowIndex', name: 'DT_RowIndex', orderable: false, searchable: false},
            {data: null, name: 'nominal', render: function ( data, type, row ) {
              return 'Rp ' + numberFormat(parseInt(data.nominal));
            }},
            {data: null, name: 'admin_fee', render: function ( data, type, row ) {
              return 'Rp ' + numberFormat(parseInt(data.admin_fee));
            }},
            {data: null, name: 'payout_total', render: function ( data, type, row ) {
              return 'Rp ' + numberFormat(parseInt(data.payout_total));
            }},
            {data: 'display_date', name: 'status', orderable: false, searchable: false},
            {data: 'display_status', name: 'status', orderable: false, searchable: false},
            {data: 'action', name: 'action', orderable: false, searchable: false},
          ]
      });

      $('#btn-filter').click(function(){
         $('.datatable').DataTable().draw(true);
      });

      $(document).on('click','.js-submit-confirm', function(e){
          e.preventDefault();
          swal({
            title: 'Apakah anda yakin ingin menghapus?',
            text: 'Data yang sudah dihapus, tidak dapat dikembalikan!',
            icon: 'warning',
            buttons: true,
            dangerMode: true,
          })
          .then((willDelete) => {
            if (willDelete) {
              $(this).closest('form').submit();
            } 
          });
      });
  });

  function numberFormat(x) {
    return x.toString().replace(/\B(?<!\.\d*)(?=(\d{3})+(?!\d))/g, ".");
  }

</script>
@endsection